<?php

$basedir=dirname(__FILE__);

include_once($basedir . '/../include/config.php');
include_once($basedir . '/../include/xml2array.php');

isset($GLOBALS['CONFIG']) or die("FATAL: " . __FILE__ . ":" . __LINE__. ": config parsing failed\n");

// generating the appropriate dirs
if (!is_dir($GLOBALS['CONFIG']['temp_dir'] . '/0.0/nextbus')) {
  mkdir($GLOBALS['CONFIG']['temp_dir'] . '/0.0/nextbus', 0755, TRUE) or die("Couldn't create " . $GLOBALS['CONFIG']['temp_dir'] . "/0.0/nextbus/");
}

$nextbus_url = 'http://webservices.nextbus.com/service/publicXMLFeed';
$agency = 'rutgers';

$routes = file_get_contents($nextbus_url . '?a=' . $agency . '&command=routeConfig');
if ($routes === false) die();

$routes = xml2array($routes);
$routes = $routes['body']['route'];

$list = array();
$stops_list = array();

for($i = 0; $i < count($routes); $i++) 
{
   // attr => array(tag, title)
   // stop => # => attr => tag, title
   $list[$i]['route_name'] = $routes[$i]['attr']['title'];   
   $list[$i]['route_id'] = $routes[$i]['attr']['tag'];
  // $list[$i]['stops'] = count($routes[$i]['stops']);   
   for ($j = 0; $j < count($routes[$i]['stop']); $j++)
   {
      if (!isset($routes[$i]['stop'][$j]['attr']['stopId']))
         continue;

      $list[$i]['stops'][$j]['stop_name'] = $routes[$i]['stop'][$j]['attr']['title'];
      $list[$i]['stops'][$j]['stop_id'] = $routes[$i]['stop'][$j]['attr']['stopId'];
      array_push($stops_list, 
         array(
            "stop_name" => $list[$i]['stops'][$j]['stop_name'], 
            "stop_id" => $list[$i]['stops'][$j]['stop_id'], 
            "lat" => $routes[$i]['stop'][$j]['attr']['lat'], 
            "lon" => $routes[$i]['stop'][$j]['attr']['lon']
         )
      );
   }

}

// unique array of stops
$stops_output = array();
$ignore_list = array('1036');
foreach ($stops_list as $check_stop)
{
   $exists = false;
   foreach ($stops_output as $with_stop)
   {
      if ($with_stop['stop_id'] == $check_stop['stop_id'])
      {
         $exists = true;
         break;
      }
   }

   if (in_array($check_stop['stop_id'], $ignore_list))
   {
      $exists = true;
   }   

   if (!$exists)
      $stops_output[] = $check_stop;
}

//sorting
foreach ($stops_output as $key => $row) {
    $stop_names[$key]  = $row['stop_name'];
    $stop_ids[$key] = $row['stop_id'];
}

array_multisort($stop_names, SORT_ASC, $stop_ids, SORT_ASC, $stops_output);

// list of stops
$file = fopen($GLOBALS['CONFIG']['temp_dir'] . '/0.0/nextbus/stops_list.txt', 'w');
fwrite($file, json_encode($stops_output));
fclose($file);

// lines -> stops
$file = fopen($GLOBALS['CONFIG']['temp_dir'] . '/0.0/nextbus/route_config.txt', 'w');
fwrite($file, json_encode($list));
fclose($file);

include('stops2db.php'); // this jsut adds all the stops in the db.

foreach ($list as $route)
{   
   exec('php ' . $basedir . '/line2stops-times.php ' . $route['route_id'] . '  &');
}

foreach ($stops_output as $stop)
{
   exec('php ' . $basedir . '/stop2lines-times.php ' . $stop['stop_id'] . '  &');
}
?>
